<HTML>
<HEAD>

<!-- Please preserve look n' feel! -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<TITLE>Sample getChannels meta macro</TITLE>

<META name="description" content="Description of the getChannels User Command">

<META name="keywords" content="macros, commands, user">

</HEAD>

<BODY BGCOLOR="#DDDDDD" TEXT="#000000">
<a name="top">
<table>
<td width=100%><td>
<IMG SRC="/doc/gifs/LIGO.gif" ALIGN=right ALT="LIGO.gif">
</table>

<h3> The <i>getChannels</i> User Commands (Meta Macro) </h3>
<b>All user commands have the form:</b>
<p>
<tt><font color="red">
<b>ldasJob</b> { -name {} -password {} -email {} } { <b>userCmd</b> -opt1 {} ... }
</tt></font>
<p>
Which is in the format of a <a href=http://www.tcl.tk/software/tcltk/><b>Tcl</b></a> command, <b>ldasJob</b>, with two required
arguments:
<ol>
<li>
A Tcl list of <b>user information</b> consisting of username,
password, and e-mail address.  All fields must be filled or
the command will be rejected.<br>
Client software which would like to receive responses from the
LDAS system on a port instead of through email can provide a
<b>hostname:port</b> combination as the email argument.  A
further feature of this method is that the hostname can be replaced
with the magic key <b>!host!</b>, and the LDAS system will use
the IP address it finds by doing a peername lookup on the
connected socket.
<li>
A <b>user command</b> in the form of a Tcl list, for which there
exists a &quot;meta&quot; macro file which can be expanded into Tcl code
which can then be evaluated by the LDAS system.
<br>
An argument need not be provided for every option.  Some options
have default values and these are described below as appropriate.
<br>
Meta macros consist of a prototype declaration of the arguments
for the given user command, and a template describing the calling
order of API specific blocks of Tcl code which are concatenated
into a larger block comprising the complete request, which can
then be distributed by the assistant manager for interpretation
by the low level API's.
<br>
These API specific blocks are maintained as API specific macro
files consisting of immediately interpretable Tcl code.
</ol>
There are individual API specific getData user commands for
retrieving frame data, metadata, and LIGO lightweight data:
<ul>
<a href="#getchannels"><li><b><i>getChannels</i></b></a>
</ul>
<!-- bottom of page pointer section --> 
<center>
<h2>
<a href="#getchannels">getChannels</a>
<IMG SRC="/doc/gifs/arrow_right.gif" ALT="arrow_right.gif">
</h2>
</center>
<!-- Here we put the stuff which will become the linked pages --> 
<hr>
<ul>
<li>
<a name="getchannels">
<b><i>getChannels</i></b>
<p>
Returns list of channel names and types, and optionally all
metadata for the channel types requested. By default the names
of all Adc and Proc channels are returned in a 'list of lists'
paired with their type as an all uppercase string indicating
'ADC' or 'PROC' as appropriate. In addition to the default
Adc and Proc types, SIM and SERIAL channel types are also
supported and can be specified using the -channeltypes option.
<p>
An exception is generated if the filename provided (or
the calcualted filename when no explicit filename is
provided) does not exist or is not readable due to
permission problems.
<p>
An e-mail with a URL pointing to the location of the results
file is sent (-returnprotocol http or ftp is supported for
retrieval of the file by mailcap/mime-types).
<p>
Calling convention (all on a single line):
<p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"username"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"user@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>getChannels</i></b> &nbsp; 
<a href=#returnprotocol>-returnprotocol</a>   
&nbsp; <font color="red"> <i>URL</i></font> &nbsp; 
   
<a href=#interferometer>-interferometer</a>   
&nbsp; <font color="red"> <i>IFO Abbrev</i></font> &nbsp;
   
<a href=#directory>-directory</a>      
&nbsp; <font color="red"> <i>directory under ::MOUNT_PT</i></font> &nbsp;
   
<a href=#filename>-filename</a>      
&nbsp; <font color="red"> <i>full path to frame file</i></font> &nbsp;
   
<a href=#frametype>-frametype</a>      
&nbsp; <font color="red"> <i>frame type</i></font> &nbsp;

<a href=#channeltypes>-channeltypes</a>      
&nbsp; <font color="red"> <i>list of channel types</i></font> &nbsp;

<a href=#metadata>-metadata</a>      
&nbsp; <font color="red"> <i>boolean (0 or 1)</i></font> &nbsp;

<a href=#time>-time</a>      
&nbsp; <font color="red"> </i>GPS time</i></font> &nbsp;
<b>}</b>
<p>
<font color="green">Option Descriptions:</font>
<ul>
<p>
<a name=returnprotocol>   
<b>-returnprotocol:</b> &nbsp; &nbsp; 
                   <tt>
                   http ftp file port
                   </tt>
<p>
<ul>
<font color=red>
Default: <i>http://some_sensible_name.ext</i>
</font><br>
<tt>
The argument to <b>-returnprotocol</b> resembles the usual
browser conventions for URL's, but is actually only a
hinting mechanism for the user to get a URL back in e-mail
or in a client.<br>
<p>
The <b>http</b>, <b>ftp</b>, and <b>file</b> options
cause a URL pointer to the location of the results to be
returned by e-mail.  Any directory structure in the location
will be ignored, the filename and extension will be used
unless they are found to break system conventions for
mime typing.<br>
The possible formats of the argument are:
<p>
<li>http://filename.ext<p> 
<li>ftp://filename.ext<p>
<li>file:/filename.ext<p>
<p>
<font color="red">
NOTES:
<ol>
<li>Embedded spaces in the argument to the -returnprotocol
option will cause the request to fail.
</ol>
</font>
</tt>
</ul>
<p>
<a name=interferometer>   
<b>-interferometer:</b> &nbsp; &nbsp; <tt>Valid IFO</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to best guess based on other options</i>
</font><br>
<tt>
The argument of the -interferometers option is an interferometer
(ifo) abbreviation as used in the file naming convention and
corresponding to the file name prefix of the frame files created
from that interferometer.
This option is used together with the -time and -frametype
options to specify a frame file with the desired list of channels.
</tt>
</ul>
<p>
<a name=directory>      
<b>-directory:</b> &nbsp; &nbsp; <tt>{}</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to the first directory in the cache</i>
</font><br>
<tt>
If this argument is provided, then the most recent file in
the directory will be used to generate the list.  If the
specified directory contains frames from multiple interferometes,
the -interferometer option can be used to specify which is
wanted.
</tt>
</ul>
<p>
<a name=filename>      
<b>-filename:</b> &nbsp; &nbsp; <tt>{}</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to best guess based on directory and ifo</i>
</font><br>
<tt>
If this argument is provided, the filename given will be used
regardless of other options.
</tt>
</ul>
<p>
<a name=frametype>      
<b>-frametype:</b> &nbsp; &nbsp; <tt>{}</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to R</i>
</font><br>
<tt>
The argument to the -frametype option is the frame type or comment
field as used in the frame file naming convention. This corresponds
to the second field of the frame file name. 
This option is used together with the -time and -interferometer
options to specify a frame file with the desired list of channels.
</tt>
</ul>
<p>
<a name=channeltypes>      
<b>-channeltypes:</b> &nbsp; &nbsp; <tt>{adc proc}</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to Adc and Proc</i>
</font><br>
<tt>
The list of channel types to report. The default includes both
<b>Adc</b> and <b>Proc</b> at present. 
Supported channel types are Adc, Proc, Sim, and Ser individually
or in any combination.
</tt>
</ul>
<p>
<a name=metadata>      
<b>-metadata:</b> &nbsp; &nbsp; <tt>Integer values ( 0,1,2 ) or any combination of the following:<br>
ADC PROC SIM SER ALL EXTENDED_ADC EXTENDED_PROC EXTENDED_SIM EXTENDED_SER EXTENDED_ALL</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to 0 (off)</i>
</font><br>
<tt>
When this option is set to <b>0</b>the command returns a list of
channel names and channel types as a 'list of lists', i.e.:<p>
{ {CH_1 ADC} {CH_2 ADC} {CH_3 PROC} }<p>
When it is set to <b>1</b> or <b>ALL</b> the command returns a 'list of lists'
of N elements where elements 0 and 1 are the channel name and type
as when the option is <b>0</b>, and elements 2 through N are each
a list consisting of a name value pair like <b>name=value</b> or
possibly <b>{name=string value}</b>:<p>
{ {CH_1 ADC name1=value {name2=extra value} ... } {CH_2 ADC ... } }<p>
When this option is set to <b>2</b> or <b>EXTENDED_ALL</b>,
the result is the same as for option <b>1</b> 
but there may be more entries of the form name=value. Both standard
metadata and extended metadata will be returned.
<p>
While this may seem cumbersome it is compact and can be parsed
easily in Tcl.<br>
Note that the channel type will be all uppercase and can be one of
<b>ADC PROC SIM</b> or <b>SERIAL</b>.
</tt>
</ul>
<p>
<a name=time>      
<b>-time:</b> &nbsp; &nbsp; <tt>Valid GPS time</tt>
<p>
<ul>
<font color=red>
Optional: <i>defaults to most recent file in directory</i>
</font><br>
<tt>
The argument to the -time option is a GPS time for which frame data exists.
This option is used together with the -frametype and -interferometer
options to specify a frame file with the desired list of channels.
</tt>
</ul>
<p>

<center>
<h2>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
<a href="#top">Return to Top</a>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
</h2>
</center>

<!-- End of getMetaData --> 

</ul>
</BODY>

<!-- VI POWERED! -->

</HTML>
